
% implements method M4 from the paper
% "Filtered Leapfrog Time Integration with Enhanced Stability Properties".
% for autonomous scalar ODEs

% This is a reference implementation only, which was written for clarity.
% The implementation is not in any way optimized for performance or 
% storage requirements.

 function y = M4(k,F,T,y0,R,M,C)
 
    N = T/k + 1;
    y = zeros(N,1);
    
    y(1) = y0;
    t = k;
    y(2) = y(1) + k*feval(F,y(1))/M;
    e1 = y(1);
    
    t = k;
    for j=2:M
         et = y(2);
         y(2) = e1 + 2*(k/M)*feval(F,y(2));  
         e1 = et;
    end
    
    for j = 3:R+2
        t = t + k;
        y(j) = y(j-2) + 2*k*feval(F,y(j-1));  
    end
    t = t - 2*k;
    
    for c = 1:C
        y(c*R-1) = ( -y(c*R-3) + 4*y(c*R-2) + 10*y(c*R-1) + 4*y(c*R) - y(c*R+1) )/16; % filter
        y(c*R) = ( -y(c*R-2) + 4*y(c*R-1) + 10*y(c*R) + 4*y(c*R+1) - y(c*R+2) )/16;
             
         for n=c*R+1:(c+1)*R+2
              if t>=(T - 10000*eps)
                 return
              end
              t = t + k;
             y(n) = y(n-2) + 2*k*feval(F,y(n-1));                            
         end  
         t = t - 2*k;
         y((c+1)*R) = ( -y((c+1)*R-2) + 4*y((c+1)*R-1) + 10*y((c+1)*R) + 4*y((c+1)*R+1) - y((c+1)*R+2) )/16; % filter
    end % C
    
    K = R*(C+1);
    I = 0;
    while (t<T)
         I = I + K;
         if t>=(T - 10000*eps)
             return
         end
         t = t + k;
         
          y(I+1) = y(I) + k*feval(F,y(I))/M;
          e1 = y(I);
   
         for j=2:M
            et = y(I+1);
            y(I+1) = e1 + 2*(k/M)*feval(F,y(I+1));  
            e1 = et;
        end
        
        for j = 2:R+2
             if t>=(T - 10000*eps)
                return
             end
             t = t + k;
             y(I+j) = y(I+j-2) + 2*k*feval(F,y(I+j-1));  
        end
        t = t - 2*k;
        
    for c = 1:C
        y(I + c*R-1) = ( -y(I + c*R-3) + 4*y(I + c*R-2) + 10*y(I + c*R-1) + 4*y(I + c*R) - y(I + c*R+1) )/16;
        y(I + c*R) = ( -y(I + c*R-2) + 4*y(I + c*R-1) + 10*y(I + c*R) + 4*y(I + c*R+1) - y(I + c*R+2) )/16;
             
         for n=I + c*R+1:I + (c+1)*R+2
              if t>=(T - 10000*eps)
                 return
              end
              t = t + k;
              y(n) = y(n-2) + 2*k*feval(F,y(n-1));                            
         end 
         t = t - 2*k;
         y(I +(c+1)*R) = ( -y(I +(c+1)*R-2) + 4*y(I +(c+1)*R-1) + 10*y(I +(c+1)*R) + 4*y(I +(c+1)*R+1) - y(I +(c+1)*R+2) )/16;
         
    end % C
      
  end % while
    
    
    
    
    
    
    
    
    
    
