% implements the leapfrog method and method M4 for example 1 from the paper
% "Filtered Leapfrog Time Integration with Enhanced Stability Properties".

function y = ex1_M4()

   T = 25;
   k = 0.1;
   N = floor(T/k) + 1;
   t = linspace(0,T,N)';
   exact = tanh(t);
   y0 = 0;
      
   y1 = LF(k,@F,T,y0);
  
   R = 20;
   M = 4;
   C = 2;

   v = M4(k,@F,T,y0,7,M,C);
   y2 = v(1:N);
        
   plot(t,y1,'b',t,y2,'g',t,exact,'k--')
   
    function f = F(v,t)
      f = 1 - v.^2;
    end

end



  
  
